Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gjt.sp.jedit.bsh.org.objectweb.asm
Interface ClassVisitor

All Known Implementing Classes:
  ClassWriter

    public interface ClassVisitor

A visitor to visit a Java class. The methods of this interface must be called in the following order: `visit` (`visitField` | `visitMethod` | `visitInnerClass`)* `visitEnd`.

Method Summary
`void` | `visit(int access, java.lang.String name, java.lang.String superName, java.lang.String[] interfaces, java.lang.String sourceFile)` Visits the header of the class.
`void` | `visitEnd()` Visits the end of the class.
`void` | `visitField(int access, java.lang.String name, java.lang.String desc, java.lang.Object value)` Visits a field of the class.
`void` | `visitInnerClass(java.lang.String name, java.lang.String outerName, java.lang.String innerName, int access)` Visits information about an inner class.
`CodeVisitor` | `visitMethod(int access, java.lang.String name, java.lang.String desc, java.lang.String[] exceptions)` Visits a method of the class.

Method Detail

### visit

    void visit(int access,
               java.lang.String name,
               java.lang.String superName,
               java.lang.String[] interfaces,
               java.lang.String sourceFile)

  Visits the header of the class.

  Parameters:
    `access` - the class's access flags (see `Constants`). This parameter also indicates if the class is deprecated.
    `name` - the internal name of the class (see `getInternalName`).
    `superName` - the internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`. May be `null`, but only for the `java.lang.Object` class.
    `interfaces` - the internal names of the class's interfaces (see `getInternalName`). May be `null`.
    `sourceFile` - the name of the source file from which this class was compiled. May be `null`.

### visitInnerClass

    void visitInnerClass(java.lang.String name,
                         java.lang.String outerName,
                         java.lang.String innerName,
                         int access)

  Visits information about an inner class. This inner class is not necessarily a member of the class being visited.

  Parameters:
    `name` - the internal name of an inner class (see `getInternalName`).
    `outerName` - the internal name of the class to which the inner class belongs (see `getInternalName`). May be `null`.
    `innerName` - the (simple) name of the inner class inside its enclosing class. May be `null` for anonymous inner classes.
    `access` - the access flags of the inner class as originally declared in the enclosing class.

### visitField

    void visitField(int access,
                    java.lang.String name,
                    java.lang.String desc,
                    java.lang.Object value)

  Visits a field of the class.

  Parameters:
    `access` - the field's access flags (see `Constants`). This parameter also indicates if the field is synthetic and/or deprecated.
    `name` - the field's name.
    `desc` - the field's descriptor (see `Type`).
    `value` - the field's initial value. This parameter, which may be `null` if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String`.

### visitMethod

    CodeVisitor visitMethod(int access,
                            java.lang.String name,
                            java.lang.String desc,
                            java.lang.String[] exceptions)

  Visits a method of the class. This method must return a new `CodeVisitor` instance (or `null`) each time it is called, i.e., it should not return a previously returned visitor.

  Parameters:
    `access` - the method's access flags (see `Constants`). This parameter also indicates if the method is synthetic and/or deprecated.
    `name` - the method's name.
    `desc` - the method's descriptor (see `Type`).
    `exceptions` - the internal names of the method's exception classes (see `getInternalName`). May be `null`.
  Returns:
    an object to visit the byte code of the method, or `null` if this class visitor is not interested in visiting the code of this method.

### visitEnd

    void visitEnd()

  Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD